package hdm.mi.growbros.repositories;

import hdm.mi.growbros.models.plant.*;
import org.springframework.data.jpa.domain.Specification;
import org.springframework.data.jpa.repository.JpaRepository;
import org.springframework.data.jpa.repository.JpaSpecificationExecutor;
import org.springframework.stereotype.Repository;

import java.util.Collection;
import java.util.List;

@Repository
public interface PlantRepository extends JpaRepository<Plant, Long>, JpaSpecificationExecutor<Plant> {

    Collection<Plant> findAllByNameContainingIgnoreCase(String searchTerm);

    Collection<Plant> findAllByWaterDemand(WaterDemand waterDemand);

    Collection<Plant> findAllByGroundType(GroundType groundType);

    Collection<Plant> findAllByLightingDemand(LightingDemand lightingDemand);

    Collection<Plant>  findAllByNutrientDemand(NutrientDemand nutrientDemand);

    Collection<Plant> findAllByPlantWeekStartGreaterThanEqualAndPlantWeekEndIsLessThanEqual(Integer plantWeekStart, Integer plantWeekEnd);

    Collection<Plant> findAllByHarvestWeekStartGreaterThanEqualAndHarvestWeekEndLessThanEqual(Integer harvestWeekStart, Integer harvestWeekEnd);

    Collection<Plant> findAllByGrowthDurationIs(Integer growthDuration);


    List<Plant> findAll(Specification<Plant> spec);
}
